import daj.*;

//
//
// InternalThread
//
//
abstract class InternalThread extends Program
{
	public Processor processor = null;

	public InternalThread (Processor processor)
	{
		this.processor = processor;
	}

	public void send (int channel, Message msg)
	{
		out (0).send (new InternalMessage (channel, msg));
	}

	public void send (Message msg)
	{
		out (0).send (new InternalMessage (-1, msg));
	}

	public InternalMessage receive ()
	{
		Message msg = in (0).receive (Processor.TIMEOUT);
		if (msg != null)
			return (InternalMessage)msg;
		return null;
	}

	public String getText ()
	{
		return processor != null ? processor.getText () : super.getText ();
	}
}

