import java.util.*;

//
//
// InvitationThread
//
//
class InvitationThread extends InternalThread
{
	/**
		The constructor of the invitation thread
	*/
	public InvitationThread (Processor processor)
	{
		super (processor);
	}

	/**
		The program executed on this thread
	*/
	public void main ()
	{
		while (true)
		{
			InternalMessage msg = receive ();
			if (msg == null || processor.State != Processor.NORMAL)
				continue;
			if (!(msg.outerMessage instanceof InvitationMsg))
				continue;

			InvitationMsg invMsg = (InvitationMsg)msg.outerMessage;

			int oldCoordinator = processor.Coordinator;
			BitSet upSet = processor.Up;
			processor.State = Processor.ELECTION;
			processor.Coordinator = invMsg.coordinator;
			processor.Group = invMsg.group;
			if (oldCoordinator == processor.index)
			{
				for (int i = 0;i < upSet.size ();i++)
					if (upSet.get (i))
						send (i, invMsg);
			}
			send (processor.Coordinator, new AcceptMsg (processor.Group));
			msg = receive ();
			boolean accepted = false;
			if (msg != null && msg.outerMessage instanceof AcceptAnswer)
			{
				AcceptAnswer answer = (AcceptAnswer)msg.outerMessage;
				accepted = answer.accepted;
			}
			if (!accepted)
				processor.Recovery ();
		}
	}
}

