import daj.*;
import java.util.*;
import java.awt.*;

/**
	The application
*/
public class Main extends Application
{
	public Processor[] processors;

	public Main ()
	{
		super ("Invitation Leader Election", 600, 450);
		processors = new Processor[10];
	}

	public Main (int n)
	{
		super ("Invitation Leader Election", 600, 450);
		processors = new Processor[n];
	}

	public static void main (String[] args)
	{
		int n = 10;
		if (args.length > 0)
		{
			n = Integer.parseInt (args[0]);
			if (n < 2)
				n = 10;
		}
		new Main (n).run ();
	}

	/**
		Constructs the nodes and links them.
		Graphically, they are disposed in the vertices of a regular polygon.
	*/
	public void construct ()
	{
		Dimension d = new Dimension (600, 450);
		int cx = d.width / 2,
			cy = d.height / 2,
			r = 2 * Math.min (cx, cy) / 3;
		Random random = new Random ();

		Node[] nodes = new Node[processors.length];

		for (int i = 0;i < nodes.length;i++)
		{
			double angle = 2 * i * Math.PI / nodes.length;
			int x = (int)(cx - Math.round (r * Math.sin (angle))),
				y = (int)(cy - Math.round (r * Math.cos (angle)));

			// 2/3 of the machines are active in the beginning
			processors[i] = new Processor ();
			nodes[i] = processors[i].OnNode (this, i, x, y);
		}
		for (int i = 0;i < nodes.length;i++)
		{
			for (int j = (i + 1) % nodes.length;j != i;j = (j + 1) % nodes.length)
			{
				if (i != j)
					link (nodes[i], nodes[j]);
			}
		}
		for (int i = 0;i < processors.length;i++)
		{
			processors[i].OnLink (this);
		}
	}

	/**
		Description of the program
	*/
	public String getText ()
	{
		return "Termination Detection Algorithm";
	}
}

