import daj.Message;

/**
	Asks a node if it is coordinator or not
*/
class AreYouCoordMsg extends Message
{
}

/**
	Answers to a <PRE>AreYouCoordMsg</PRE>
*/
class AreYouCoordAnswer extends Message
{
	public boolean isCoordinator = false;

	public AreYouCoordAnswer (boolean isCoordinator)
	{
		this.isCoordinator = isCoordinator;
	}
}

/**
	Asks the coordinator whether it is still in the Group or not
*/
class AreYouThereMsg extends Message
{
	public Group group;

	public AreYouThereMsg (Group group)
	{
		this.group = group;
	}
}

/**
	The coordinator is (not) in the group
*/
class AreYouThereAnswer extends Message
{
	public boolean stillCoordinator;

	public AreYouThereAnswer (boolean stillCoordinator)
	{
		this.stillCoordinator = stillCoordinator;
	}
}

/**
	Invites to join the group Group with the coordinator Coordinator
*/
class InvitationMsg extends Message
{
	public int coordinator;
	public Group group;

	public InvitationMsg (int coordinator, Group group)
	{
		this.group = group;
		this.coordinator = coordinator;
	}
}

/**
	Are you ready and in my group ?
*/
class ReadyMsg extends Message
{
	public Group group;

	public ReadyMsg (Group group)
	{
		this.group = group;
	}
}

/**
	I am (not) in the group Group
*/
class ReadyAnswer extends Message
{
	public boolean inGroup;
	public Group group;

	public ReadyAnswer (boolean inGroup, Group group)
	{
		this.inGroup = inGroup;
		this.group = group;
	}
}

/**
	Asks the coordinator to accept the sender into the group
*/
class AcceptMsg extends Message
{
	public Group group;

	public AcceptMsg (Group group)
	{
		this.group = group;
	}
}

/**
	You were (not) accepted in my group
*/
class AcceptAnswer extends Message
{
	public boolean accepted;

	public AcceptAnswer (boolean accepted)
	{
		this.accepted = accepted;
	}
}
